#include <cstdio>
#include <cstdlib>

void usage()
{
	printf(
"Usage: .exe input output from [to]\n"
"  Upsample with 'point' filter ('nearest' filter')\n"
"    input  - input 8 bit mono signed/unsigned RAW PCM\n"
"    output - output 8 bit mono signed/unsigned RAW PCM\n"
"    from   - input sample rate\n"
"    to     - output sample rate (default: 44100)\n"
"\n"
"Author: r57shell@uralweb.ru\n");
	exit(0);
}

int main(int argc,char **args)
{
	if (argc!=4 && argc!=5)
		usage();

	FILE *f = fopen(args[1],"rb");
	if (!f)
	{
		printf("Can't open \"%s\"\n",args[1]);
		usage();
	}
	FILE *o = fopen(args[2],"wb");
	if (!o)
	{
		fclose(f);
		printf("Can't open \"%s\"\n",args[2]);
		usage();
	}
	int from = atoi(args[3]);
	int to = 44100;
	if (argc>4)
		to = atoi(args[4]);
	int frac = double(from)/to*0x10000;
	int t = 0x10000;
	char c;
	for (;;)
	{
		if (t&0x10000)
		{
			t-=0x10000;
			int readed = fread(&c,1,1,f);
			if (!readed)
				break;
		}
		fwrite(&c,1,1,o);
		t+=frac;
	}
	fclose(f);
	fclose(o);
	return 0;
}
